#include <iostream>

// Sequencecontainer aus der Standard Template Library
#include <vector>   // dynamisches Feld
#include <list>     // Liste
#include <deque>    // Schlange mit zwei Enden - double-ended queue  

#include <algorithm>  // copy

int
main()
{
  double Adble[3] = {0.0, 3.0, 6.0};
  for (int i = 0; i < 3; i++)
  { std::cout << Adble[i] << ' '; }
  std::cout << std::endl;
  for (double* ptr = Adble; 
       ptr != Adble + 3;        // ptr < Adble + 3
       ptr++)
  { std::cout << *ptr << ' '; }
  std::cout << std::endl;

  std::vector< double>  Vdble;
  Vdble.push_back( 1.0);
  Vdble.push_back( 2.0);
  for (int i = 0; i < Vdble.size(); i++)
  { std::cout << Vdble[i] << ' '; }
  std::cout << std::endl;
  for (std::vector<double>::iterator vit = Vdble.begin(); 
       vit != Vdble.end();
       vit++)
  { std::cout << *vit << ' '; }
  std::cout << std::endl;

  std::list< double>  Ldble;
  Ldble.push_front( 4.0);
  Ldble.push_back( 8.0);
  for (std::list<double>::iterator lit = Ldble.begin(); 
       lit != Ldble.end();
       ++lit )
  { std::cout << *lit << '-'; }
  std::cout << std::endl;

  std::deque< std::vector< double> >  Dvdble;
  Dvdble.push_back( Vdble);
  std::list<double>::iterator lit = Ldble.begin(); 
  std::vector<double>::iterator vit = Vdble.begin();
  while ( lit != Ldble.end())
  { *vit++ = *lit++; }
  Dvdble.push_back( Vdble);
  for ( std::deque< std::vector< double> >::iterator dit = Dvdble.begin();
        dit != Dvdble.end();
        ++dit )
  { 
    for ( std::vector< double>::iterator vit = (*dit).begin();
          vit != (*dit).end();
          ++vit )
    { std::cout << *vit << "  "; }
    std::cout << endl;
  }

  // template < typename InputIterator, typename OutputIterator>
  // OutputIterator
  // copy( InputIterator, InputIterator, OutputIterator)
  copy( Ldble.begin(), Ldble.end(), Adble);

  for (int i = 0; i < 3; i++)
  { std::cout << Adble[i] << ' '; }
  std::cout << std::endl;

  return 0;
}


