#ifndef STACK1_H
#define STACK1_H

class stack
// Ein Objekt von Typ stack ist ein Folge von ints 
// Alle Operationen brauchen konstante Zeit; f"ur push ist das amortisiert, 
// f"ur alle anderen ist das worst-case. Der Platzbedarf ist proportional zur
// maximalen Gr"o\3e des Kellers
{
  public:
    stack();                 // Defaultkonstruktor
    stack(const stack&);     // Copykonstruktor
    ~stack();                // Destruktor

    stack& operator=(const stack&);   // Zuweisung

    void   push(int x);   // legt x auf dem Keller ab
    void   pop();         // entfernt oberstes Element
                          // Vorbedingung: Keller ist nicht leer
    int    top() const;   // gibt oberstes Kellerelement aus
                          // Vorbedingung: Keller ist nicht leer
    bool   empty() const; // liefert true, falls Keller leer, sonst false

  private: 
    // Ein stack wird dargestellt durch ein array A und zwei integer tp (top pointer)
    // und sz (size). sz ist die Groe3e von A, der Keller besteht aus den Elementen 
    // 0 bis tp von A, und natuerlich ist tp < sz. Ferner tp >= -1. Der Keller ist 
    // leer genau dann wenn tp == -1. 

    int   sz;
    int   tp;
    int*  A;
};
#endif // STACK1
